/*******************************************************************************
Copyright(c) 2000 - 2002 Analog Devices. All Rights Reserved.
Developed by Joint Development Software Application Team, IPDC, Bangalore, India
for Blackfin DSPs  ( Micro Signal Architecture 1.0 specification).

By using this module you agree to the terms of the Analog Devices License
Agreement for DSP Software. 
********************************************************************************
File name   : test_sadct.c
Description : This module tests sadct() routine.
******************************************************************************/
#include<stdio.h>
#include "InterlacedSACOS.h"
#include "output1.h"

int error_flag = 0;
void (*f1)();
int cycle_count[10];

void _sadct();

main()
{

    int i,j;

    f1 = _sadct;

//Test case 1
    for(i=0;i<8;i++)
        for(j=0;j<8;j++)
        {
            data[i*8+j]=(i+1)*(30-j);
            if((i+j)>6)
                shape[i*8+j]=255;
            else
                shape[i*8+j]=0;
        }

    cycle_count[0] = Compute_Cycle_Count(&data,&shape,&out,&coeff);
                            //This function inturn calls sadct()

    for(i=0;i<8;i++)
        for(j=0;j<8;j++)
            if(abs(out[i*8+j] - exp_out[i*8+j]) > MAX_PERMISSIBLE_ERROR)
            {
                error_flag = error_flag | 1;
            }   

    #ifdef PRINTF_SUPPORT
        if(error_flag & 1)
            printf("Test Case 1 failed\n");
        else
            printf("Test Case 1 passed\n");
    #endif
    
    printf("cycle_count[0] = %d",cycle_count[0]);
}

