	.module P1_AVR_TWI.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_TWI.c
	.dbfunc e Init_TWI_Master _Init_TWI_Master fV
	.even
_Init_TWI_Master::
	.dbline -1
	.dbline 93
; /**************************************************************
; 
;    Program Title:  P1 AVR Boot/Monitor
;    
;    Program Name:  P1_AVR_TWI.c	Version: 0.88
;    
;    Author:  SS	  			    Date:  August 10, 2005
;    
;    Compiled with ImageCraft ICCAVR Standard V6.29
;    
;    This file contains routines that implement an TWI Master and Slave
;    interrupt driven controller.
;    
;    Copyright 2004-2007, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright (C) 2005-2007 by SOC Robotics, Inc. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-machines.com
;  */
; 
; /*
;  * $Log: P1_Monitor.c,v $
;  * Revision 0.88  2007/07/23 16:40:20  SS
;  *    Port to ATmega644
;  * Revision 0.55  2005/07/17 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom32v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include "P1_AVR_Uart.h"
; #include "P1_AVR_Defines.h"
; #include "P1_AVR_Extern.h"
; 
; // Motor control Commands
; #define    MOTORBOTHFORWARD  	'1'    //    FB - forward both motors
; #define    MOTORRIGHTFORWARD  	'2'    //    FR - forward right motor
; #define    MOTORLEFTFORWARD  	'3'    //    FL - forward left motor
; #define    MOTORBOTHREVERSE  	'4'    //    RB - reverse both motors
; #define    MOTORREVERSERIGHT  	'5'    //    RR - reverse right motor
; #define    MOTORREVERSELEFT  	'6'    //    RL - reverse left motor
; #define    ROTATECW				'c'	   //    Rotate clockwise
; #define    ROTATECCW			'w'    //    Rotate counter clockwise
; //    Axxx - Acceleration rate xxx - 000 to 999
; #define    MOTORACCELERATION  	'7'    
; #define    MOTORHALT  	        'h'    //    H - Halt 
; #define    LIGHTCONTROL  	    '9'    //    LxH - turn light x[O]N/O[F]F
; //    Sxxx - set speed to xxx - 000 to 999 (relative as ratio)
; #define    MOTORRIGHTSPEED      'a'
; //    Sxxx - set speed to xxx - 000 to 999 (relative as ratio)    
; #define    MOTORLEFTSPEED       'b'    
; #define    RESETCONTROLLER  	'g'    //    E - reset to defaults
; 
; // Initialize the TWI Master interface I2C
; //  TBD - pull the default slave address from EEPROM
; //        otherwise use default
; void  Init_TWI_Master(void)
; {
	.dbline 94
;  	  TWBR = 2;  // Set bit rate to about 100K with 8MHz clock
	ldi R24,2
	out 0x0,R24
	.dbline 95
; 	  TWCR = (1<<TWINT)|(1<<TWEN);  // Turn 2 wire port on  SDA - PC1, SCL - PC0
	ldi R24,132
	out 0x36,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Init_TWI_Slave _Init_TWI_Slave fV
;    generalcall -> R18
;   slaveaddress -> R16
	.even
_Init_TWI_Slave::
	.dbline -1
	.dbline 101
; }
; 
; // Initialize the TWI Slave interface I2C
; //  Set TWI slave address and optionally General Call
; void  Init_TWI_Slave(unsigned char slaveaddress,char generalcall)
; {
	.dbline 102
;  	  if(generalcall) TWAR = (slaveaddress<<1) | TWGCE;
	tst R18
	breq L3
X0:
	.dbline 102
	mov R2,R16
	lsl R2
	out 0x2,R2
	xjmp L4
L3:
	.dbline 103
; 	  else TWAR = (slaveaddress<<1);
	mov R2,R16
	lsl R2
	out 0x2,R2
L4:
	.dbline 106
; 	  // Turn 2 wire port on, enable slave address recognition,
; 	  // clear TWINT bit -  SDA - PC1, SCL - PC0
; 	  TWCR = (1<<TWINT)|(1<<TWEA)|(1<<TWEN);  
	ldi R24,196
	out 0x36,R24
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbsym r generalcall 18 c
	.dbsym r slaveaddress 16 c
	.dbend
	.dbfunc e TWI_Error _TWI_Error fV
	.even
_TWI_Error::
	.dbline -1
	.dbline 110
; }
; 
; void TWI_Error(void)
; {
	.dbline -2
L5:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TWI_Off _TWI_Off fV
	.even
_TWI_Off::
	.dbline -1
	.dbline 114
; }
; 
; void TWI_Off(void)
; {
	.dbline 115
;  	 TWCR = (1<<TWINT);  // Reset TWI - this allows SDA to go high
	ldi R24,128
	out 0x36,R24
	.dbline -2
L6:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TWI_Transmit _TWI_Transmit fc
;   countervalue -> R22,R23
;     twistatus3 -> R10
;     twistatus2 -> R12
;     twistatus1 -> R14
;     statusmode -> y+10
;         txdata -> R20
;   slaveaddress -> R22
	.even
_TWI_Transmit::
	xcall push_xgsetF0FC
	mov R20,R18
	mov R22,R16
	.dbline -1
	.dbline 121
; }
; 
; // Transmit one byte to slave processor via 2-wire interface
; unsigned char  TWI_Transmit(unsigned char slaveaddress, unsigned char txdata,
;                             unsigned char statusmode)
; {
	.dbline 125
;       unsigned char twistatus1,twistatus2,twistatus3;
; 	  int countervalue;
; 	  
; 	  twistatus1=twistatus2=twistatus3 = 0;
	clr R10
	clr R12
	clr R14
	.dbline 128
; 
; 	  // Send start command and wait for completion
; 	  TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTA);
	ldi R24,164
	out 0x36,R24
L8:
	.dbline 129
; 	  while(!(TWCR & (1<<TWINT)))  ;	
L9:
	.dbline 129
	in R2,0x36
	sbrs R2,7
	rjmp L8
X1:
	.dbline 130
; 	  twistatus1 = TWSR;
	in R14,0x1
	.dbline 132
; 	  // Send slave address and write command 
; 	  TWDR = (slaveaddress<<1) | SLA_W;
	mov R2,R22
	lsl R2
	out 0x3,R2
	.dbline 133
; 	  TWCR = (1<<TWINT)|(1<<TWEN);
	ldi R24,132
	out 0x36,R24
L11:
	.dbline 134
; 	  while(!(TWCR & (1<<TWINT)))  ;  
L12:
	.dbline 134
	in R2,0x36
	sbrs R2,7
	rjmp L11
X2:
	.dbline 135
; 	  twistatus2 = TWSR; 
	in R12,0x1
	.dbline 137
; 	  // Send data byte and wait for transmission to complete
; 	  TWDR = txdata;    
	out 0x3,R20
	.dbline 138
; 	  TWCR = (1<<TWINT)|(1<<TWEN);
	ldi R24,132
	out 0x36,R24
	.dbline 139
; 	  countervalue = 0;
	clr R22
	clr R23
L14:
	.dbline 140
; 	  while(!(TWCR & (1<<TWINT))) {
	.dbline 142
; //		  if(countervalue++>90) break;
; 		  } 	 
L15:
	.dbline 140
	in R2,0x36
	sbrs R2,7
	rjmp L14
X3:
	.dbline 143
; 	  twistatus3 = TWSR;
	in R10,0x1
	.dbline 153
; /*	  // Send second data byte and wait for transmission to complete
; 	  TWDR = 0x45;    
; 	  TWCR = (1<<TWINT)|(1<<TWEN);
; 	  countervalue = 0;
; 	  while(!(TWCR & (1<<TWINT))) {
; 		  if(countervalue++>40) break;
; 		  } 	 
; 	  twistatus3 = TWSR;
; */
; 	TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO); 
	ldi R24,148
	out 0x36,R24
	.dbline 155
; 	  // Optionally output status bytes
; 	  if((txdata!=0x55)&(statusmode==VERBOSE)) {
	cpi R20,85
	breq L19
X4:
	ldi R22,1
	ldi R23,0
	xjmp L20
L19:
	clr R22
	clr R23
L20:
	ldd R24,y+10
	cpi R24,2
	brne L21
X5:
	ldi R20,1
	ldi R21,0
	xjmp L22
L21:
	clr R20
	clr R21
L22:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X6
	tst R3
	breq L17
X6:
	.dbline 155
	.dbline 156
; 	      puts("\n\rTWI status bytes = "); 
	ldi R16,<L23
	ldi R17,>L23
	xcall _puts
	.dbline 157
; 	      bytetohex(twistatus1);
	mov R16,R14
	xcall _bytetohex
	.dbline 158
; 	      puts(hexbyte); putchar(' ');
	ldi R16,<_hexbyte
	ldi R17,>_hexbyte
	xcall _puts
	.dbline 158
	ldi R16,32
	xcall _putchar$device_specific$
	.dbline 159
; 	      bytetohex(twistatus2);
	mov R16,R12
	xcall _bytetohex
	.dbline 160
; 	      puts(hexbyte); putchar(' '); 
	ldi R16,<_hexbyte
	ldi R17,>_hexbyte
	xcall _puts
	.dbline 160
	ldi R16,32
	xcall _putchar$device_specific$
	.dbline 161
; 	      bytetohex(twistatus3);
	mov R16,R10
	xcall _bytetohex
	.dbline 162
; 	      puts(hexbyte);
	ldi R16,<_hexbyte
	ldi R17,>_hexbyte
	xcall _puts
	.dbline 163
; 		  }
L17:
	.dbline 169
; 	  
; 	  // Send stop command
; //	  if(countervalue>90) return 0x02;
; //	  else TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO); 
; 
; 	  return 0x01;  // OK
	ldi R16,1
	.dbline -2
L7:
	.dbline 0 ; func end
	xjmp pop_xgsetF0FC
	.dbsym r countervalue 22 I
	.dbsym r twistatus3 10 c
	.dbsym r twistatus2 12 c
	.dbsym r twistatus1 14 c
	.dbsym l statusmode 10 c
	.dbsym r txdata 20 c
	.dbsym r slaveaddress 22 c
	.dbend
	.dbfunc e TWI_Master_Receive _TWI_Master_Receive fc
;         rxdata -> R10
;   slaveaddress -> R12
	.even
_TWI_Master_Receive::
	st -y,R10
	st -y,R12
	mov R12,R16
	.dbline -1
	.dbline 174
; }
; 
; // Receive one byte from slave processor via 2-wire interface
; unsigned char TWI_Master_Receive(unsigned char slaveaddress)
; {
	.dbline 177
;  	  unsigned char rxdata;
; 	  
; 	  rxdata = 0;
	clr R10
	.dbline 178
;  	  TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTA);  // Send start condition
	ldi R24,164
	out 0x36,R24
L25:
	.dbline 179
; 	  while(!(TWCR & (1<<TWINT)))  ;	  // Wait for TWINT flag - start done
L26:
	.dbline 179
	in R2,0x36
	sbrs R2,7
	rjmp L25
X7:
	.dbline 181
; 	  //if((TWSR & 0xF8) != TWI_START) twi_error();  // See if Start condition
; 	  TWDR = (slaveaddress<<1) | SLA_R;	 // Request data command
	mov R24,R12
	lsl R24
	ori R24,1
	out 0x3,R24
	.dbline 182
; 	  TWCR = (1<<TWINT)|(1<<TWEN);		  
	ldi R24,132
	out 0x36,R24
L28:
	.dbline 183
; 	  while(!(TWCR & (1<<TWINT)))  ;	  // Wait for ACK/NACK 
L29:
	.dbline 183
	in R2,0x36
	sbrs R2,7
	rjmp L28
X8:
	.dbline 184
; 	  if((TWSR & 0xF8) != MT_SLA_ACK) TWI_Error();  // See if ACK/NACK received  
	in R24,0x1
	andi R24,248
	cpi R24,24
	breq L31
X9:
	.dbline 184
	xcall _TWI_Error
L31:
	.dbline 186
; 
; 	  TWCR = (1<<TWINT)|(1<<TWEA)|(1<<TWEN);
	ldi R24,196
	out 0x36,R24
L33:
	.dbline 187
; 	  while(!(TWCR & (1<<TWINT)))  ; 	  // Wait for reception to complete
L34:
	.dbline 187
	in R2,0x36
	sbrs R2,7
	rjmp L33
X10:
	.dbline 188
; 	  rxdata = TWDR;      			  	  // Send data byte 
	in R10,0x3
	.dbline 202
; 	  
; 	  // Get next receive byte
; 	  /*
; 	  TWCR = (1<<TWINT)|(1<<TWEN);
; 	  countervalue = 0;
; 	  while(!(TWCR & (1<<TWINT))) {
; 		 if(countervalue++>40) break;
; 		 } 	
; 	  inbyte = TWDR;    
; 	  twistatus4 = TWSR;
; 	  */
; 	  
; 	  //if((TWSR & 0xF8) != MT_DATA_ACK) TWI_Error();  // See if data received
; 	  TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);   // transmit stop
	ldi R24,148
	out 0x36,R24
	.dbline 203
; 	  return rxdata;
	mov R16,R10
	.dbline -2
L24:
	.dbline 0 ; func end
	ld R12,y+
	ld R10,y+
	ret
	.dbsym r rxdata 10 c
	.dbsym r slaveaddress 12 c
	.dbend
	.dbfunc e TestTWI _TestTWI fV
	.even
_TestTWI::
	sbiw R28,1
	.dbline -1
	.dbline 207
; }
; 								
; void  TestTWI(void)
; {
	.dbline 208
; 	TWI_Transmit(0x15,0x55,QUIET);
	ldi R24,1
	std y+0,R24
	ldi R18,85
	ldi R16,21
	xcall _TWI_Transmit
	.dbline 209
; 	TWI_Transmit(0x15,0xaa,QUIET);
	ldi R24,1
	std y+0,R24
	ldi R18,170
	ldi R16,21
	xcall _TWI_Transmit
	.dbline -2
L36:
	.dbline 0 ; func end
	adiw R28,1
	ret
	.dbend
	.area lit(rom, con, rel)
L38:
	.byte 49,50
	.byte 51,53
	.byte 54,52
	.byte 'c,'w
	.byte 49,50
	.byte 51,53
	.byte 54,52
	.byte 'c,'w
	.byte 49,52
	.byte 'c,'w
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_TWI.c
	.dbfunc e Sumo1_Pattern _Sumo1_Pattern fV
;         inchar -> R10
;        pattern -> y+1
;              i -> R20,R21
	.even
_Sumo1_Pattern::
	xcall push_xgset300C
	sbiw R28,21
	.dbline -1
	.dbline 213
; }
; 
; void Sumo1_Pattern(void)
; {
	.dbline 214
;     unsigned char pattern[20] = {'1','2','3','5','6','4','c','w',
	ldi R24,<L38
	ldi R25,>L38
	movw R30,R28
	adiw R30,1
	ldi R16,20
	ldi R17,0
	st -y,R31
	st -y,R30
	st -y,R25
	st -y,R24
	xcall asgncblk
	xjmp L40
L39:
	.dbline 221
; 			 	  			  	 '1','2','3','5','6','4','c','w',
; 								 '1','4','c','w'};
; 	char inchar;
; 	int i;
; 	
; 	//puts("\n\rDo repetitive pattern - press any key to stop");
; 	while(!(inchar=getcharnw())) {
	.dbline 222
; 	    for(i=0; i<20; i++) {
	clr R20
	clr R21
L42:
	.dbline 222
	.dbline 223
; 	        TWI_Transmit(0x15,pattern[i],QUIET);
	ldi R24,1
	std y+0,R24
	movw R24,R28
	adiw R24,1
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldd R18,z+0
	ldi R16,21
	xcall _TWI_Transmit
	.dbline 224
; 		    LongDelay(8);
	ldi R16,8
	ldi R17,0
	xcall _LongDelay
	.dbline 225
; 		    }
L43:
	.dbline 222
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 222
	cpi R20,20
	ldi R30,0
	cpc R21,R30
	brlt L42
X11:
	.dbline 226
; 		}
L40:
	.dbline 221
	xcall _getcharnw
	mov R10,R16
	tst R10
	breq L39
X12:
	.dbline 227
; 	TWI_Transmit(0x15,'h',QUIET);
	ldi R24,1
	std y+0,R24
	ldi R18,104
	ldi R16,21
	xcall _TWI_Transmit
	.dbline -2
L37:
	.dbline 0 ; func end
	adiw R28,21
	xjmp pop_xgset300C
	.dbsym r inchar 10 c
	.dbsym l pattern 1 A[20:20]c
	.dbsym r i 20 I
	.dbend
	.dbfunc e Sumo1_Controller _Sumo1_Controller fV
;         inchar -> R20
	.even
_Sumo1_Controller::
	st -y,R20
	st -y,R22
	sbiw R28,1
	.dbline -1
	.dbline 231
; }
; 
; void Sumo1_Controller(void)
; {	 
	xjmp L48
L47:
	.dbline 236
; 	unsigned char inchar;
; 	
;     //puts("Sumo 1 Command Controller");
; 	//puts("\n\rEnter command[1,2,3,4,5,6,h,c,w][e to exit]: ");
;  	while((inchar=getchar())!='e')  {
	.dbline 237
; 	    putchar(inchar);
	mov R16,R20
	xcall _putchar$device_specific$
	.dbline 238
; 		if(inchar=='p') Sumo1_Pattern();
	cpi R20,112
	brne L50
X13:
	.dbline 238
	xcall _Sumo1_Pattern
	xjmp L51
L50:
	.dbline 239
; 		else {
	.dbline 240
; 		    if(TWI_Transmit(0x15,inchar,QUIET)!=0x01) {
	ldi R24,1
	std y+0,R24
	mov R18,R20
	ldi R16,21
	xcall _TWI_Transmit
	cpi R16,1
	breq L52
X14:
	.dbline 240
	.dbline 241
; 		        TWI_Off();
	xcall _TWI_Off
	.dbline 242
; 		        Init_TWI_Master();
	xcall _Init_TWI_Master
	.dbline 243
; 		        }
L52:
	.dbline 244
; 			}
L51:
	.dbline 246
; 		//puts("\n\rEnter command[1,2,3,4,5,6,h,c,w][e to exit]: ");
; 		}
L48:
	.dbline 236
	xcall _getchar$device_specific$
	mov R22,R16
	mov R20,R22
	cpi R16,101
	brne L47
X15:
	.dbline -2
L46:
	.dbline 0 ; func end
	adiw R28,1
	ld R22,y+
	ld R20,y+
	ret
	.dbsym r inchar 20 c
	.dbend
	.dbfunc e TWI_Write_Slave _TWI_Write_Slave fV
;     twistatus3 -> <dead>
;     twistatus2 -> <dead>
;     twistatus1 -> <dead>
;   countervalue -> R10,R11
;         inchar -> R20
	.even
_TWI_Write_Slave::
	xcall push_xgsetF00C
	sbiw R28,1
	.dbline -1
	.dbline 249
; }
; void TWI_Write_Slave()
; {
	.dbline 253
;     unsigned char inchar,twistatus1,twistatus2,twistatus3;
; 	int countervalue;
; 	
;     puts(" TWI Master Write Active\n\r");
	ldi R16,<L55
	ldi R17,>L55
	xcall _puts
	.dbline 254
; 	Init_TWI_Master();
	xcall _Init_TWI_Master
	.dbline 255
; 	puts("Enter character ['e'-exit z-sumo1]: ");
	ldi R16,<L56
	ldi R17,>L56
	xcall _puts
	xjmp L58
L57:
	.dbline 256
; 	while((inchar=getchar())!='e')  {
	.dbline 257
; 	    countervalue = 0;
	clr R10
	clr R11
	.dbline 258
; 		putchar(inchar);
	mov R16,R20
	xcall _putchar$device_specific$
	.dbline 260
; 		// Output byte on TWI continuously
; 		if(inchar=='z') {
	cpi R20,122
	brne L60
X16:
	.dbline 260
	.dbline 261
; 		    Sumo1_Controller();
	xcall _Sumo1_Controller
	.dbline 262
; 			puts("Press 'e' to exit");
	ldi R16,<L62
	ldi R17,>L62
	xcall _puts
	.dbline 263
; 			}
L60:
	.dbline 264
; 		if(inchar=='r') {
	cpi R20,114
	brne L63
X17:
	.dbline 264
	xjmp L66
L65:
	.dbline 265
; 		    while(!(inchar=getcharnw()))  {
	.dbline 266
; 			    if(TWI_Transmit(0x15,0x55,VERBOSE)!=0x01) {
	ldi R24,2
	std y+0,R24
	ldi R18,85
	ldi R16,21
	xcall _TWI_Transmit
	cpi R16,1
	breq L68
X18:
	.dbline 266
	.dbline 267
; 		            TWI_Off();
	xcall _TWI_Off
	.dbline 268
; 		            Init_TWI_Master();
	xcall _Init_TWI_Master
	.dbline 269
; 		            }
L68:
	.dbline 270
; 			    }
L66:
	.dbline 265
	xcall _getcharnw
	mov R20,R16
	tst R20
	breq L65
X19:
	.dbline 271
; 			}
	xjmp L64
L63:
	.dbline 272
; 		else {
	.dbline 273
; 		    if(TWI_Transmit(0x15,inchar,VERBOSE)!=0x01) {
	ldi R24,2
	std y+0,R24
	mov R18,R20
	ldi R16,21
	xcall _TWI_Transmit
	mov R22,R16
	cpi R16,1
	breq L70
X20:
	.dbline 273
	.dbline 274
; 		        TWI_Off();
	xcall _TWI_Off
	.dbline 275
; 		        Init_TWI_Master();
	xcall _Init_TWI_Master
	.dbline 276
; 		        }
L70:
	.dbline 277
; 			}
L64:
	.dbline 278
;         puts("\n\rEnter character('e' to exit): ");
	ldi R16,<L72
	ldi R17,>L72
	xcall _puts
	.dbline 279
; 	    }
L58:
	.dbline 256
	xcall _getchar$device_specific$
	movw R10,R16
	mov R22,R10
	mov R20,R22
	cpi R16,101
	brne L57
X21:
	.dbline 280
; 	TWI_Off();
	xcall _TWI_Off
	.dbline 281
; 	puts("\n\r");
	ldi R16,<L73
	ldi R17,>L73
	xcall _puts
	.dbline -2
L54:
	.dbline 0 ; func end
	adiw R28,1
	xjmp pop_xgsetF00C
	.dbsym l twistatus3 2 c
	.dbsym l twistatus2 2 c
	.dbsym l twistatus1 2 c
	.dbsym r countervalue 10 I
	.dbsym r inchar 20 c
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_TWI.c
L73:
	.blkb 3
	.area idata
	.byte 10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_TWI.c
L72:
	.blkb 33
	.area idata
	.byte 10,13,'E,'n,'t,'e,'r,32,'c,'h,'a,'r,'a,'c,'t,'e
	.byte 'r,40,39,'e,39,32,'t,'o,32,'e,'x,'i,'t,41,58,32
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_TWI.c
L62:
	.blkb 18
	.area idata
	.byte 'P,'r,'e,'s,'s,32,39,'e,39,32,'t,'o,32,'e,'x,'i
	.byte 't,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_TWI.c
L56:
	.blkb 37
	.area idata
	.byte 'E,'n,'t,'e,'r,32,'c,'h,'a,'r,'a,'c,'t,'e,'r,32
	.byte 91,39,'e,39,45,'e,'x,'i,'t,32,'z,45,'s,'u,'m,'o
	.byte 49,93,58,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_TWI.c
L55:
	.blkb 27
	.area idata
	.byte 32,'T,'W,'I,32,'M,'a,'s,'t,'e,'r,32,'W,'r,'i,'t
	.byte 'e,32,'A,'c,'t,'i,'v,'e,10,13,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_TWI.c
L23:
	.blkb 22
	.area idata
	.byte 10,13,'T,'W,'I,32,'s,'t,'a,'t,'u,'s,32,'b,'y,'t
	.byte 'e,'s,32,61,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\P1AVR6~1\P1_AVR_TWI.c
; }
; 
