// **************************************************************
//
//  File:  ICM109S.h			Version: 0.45
//
//  Date:  December 23, 2004		
//
//  ICM109S Definitions for CM200-20 2Megapixel Digital Camera Module
//
//  Copyright 2004, SOC Machines, Inc.  All rights reserved.
//
// **************************************************************
/*
 * Copyright (C) 2005-2006 by SOC Robotics, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 4. Redistribution is only allowed in combination with SOC Machines, 
 *    Inc. hardware products.
 *
 * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.soc-machines.com
 */

/*
 * $Log: ICM109S.h,v $
 * Revision 0.54  2005/06/04 18:36:42  steve
 * Preview release
 *
 */
#define   ICM109S_Write_ADD			0x20
#define	  ICM109S_Read_ADD			0x21
//
//  Sub-Address Register Definitions
//
#define   CM200_PARTCONTROL			0x00
#define   CM200_TIMINGCONTROL_LOW	0x01
#define   CM200_TIMINGCONTROL_HIGH	0x02
#define   CM200_WIDTH_L				0x0C
#define   CM200_WIDTH_H				0x0D
#define   CM200_HEIGHT_L			0x0E
#define   CM200_HEIGHT_H			0x0F
#define   CM200_COLBEGIN_L			0x10
#define   CM200_COLBEFIN_H			0x11
#define   CM200_ROWBEGIN_L			0x14
#define   CM200_ROWBEGIN_H			0x15
#define   CM200_HSYNCEND_L			0x18
#define   CM200_HSYNCEND_H			0x19
#define   CM200_VSYNCEND_L			0x1A
#define   CM200_VSYNCEND_H			0x1B
#define   CM200_EXPOSETIME_L		0x1C
#define   CM200_EXPOSETIME_H		0x1D
#define   CM200_M1_L				0x20
#define   CM200_M1_H				0x21
#define   CM200_M2_L				0x22
#define   CM200_M2_H				0x23
#define   CM200_M3_L				0x24
#define   CM200_M3_H				0x25
#define   CM200_M4_L				0x26
#define   CM200_M4_H				0x27
#define   CM200_DARKDATA_L			0x40
#define   CM200_DARKDATA_H			0x41
#define   CM200_HIGHLIMIT_L			0x42
#define   CM200_HIGHLIMIT_H			0x43
#define   CM200_LOWLIMIT_L			0x44
#define   CM200_LOWLIMIT_H			0x45
#define   CM200_INOUTSEL			0x52
#define   CM200_RAMPSEL				0x53
#define   CM200_DSRST_L				0x54
#define   CM200_DSRST_H				0x55
#define   CM200_DSDATA_L			0x56
#define   CM200_DSDATA_H			0x57
#define   CM200_ID_L				0x82
#define   CM200_ID_H				0x83
#define   CM200_FLASHBEGIN_L		0x84
#define   CM200_FLASHBEGIN_H		0x85
#define   CM200_FLASHEND_L			0x86
#define   CM200_FLASHEND_H			0x87
#define   CM200_BWIDTHBEGIN_L		0x88
#define   CM200_BWIDTHBEGIN_H		0x89
#define   CM200_BWIDTHEND_L			0x8A
#define   CM200_BWIDTHEND_H			0x8B
#define   CM200_BHEIGHTBEGIN_L		0x8C
#define   CM200_BHEIGHTBEGIN_H		0x8D
#define   CM200_BHEIGHTEND_L		0x8E
#define   CM200_BHEIGHTEND_H		0x8F
#define   CM200_RSTSEL				0x90
#define   CM200_BITCONTROL			0x94
#define   CM200_WTBEGIN_L			0x97
#define   CM200_WTBEGIN_H			0x98
#define   CM200_WTEND_L				0x99
#define   CM200_WTEND_H				0x9A
#define   CM200_SUBENTIME_L			0x9B
#define   CM200_SUBENTIME_H			0x9C
#define   CM200_WIDTH_LC			0xA1
#define   CM200_WIDTH_HC			0xA2
#define   CM200_HEIGHT_LC			0xA3
#define   CM200_HEIGHT_HC			0xA4
#define   CM200_COLBEGIN_LC			0xA5
#define   CM200_COLBEGIN_HC			0xA6
#define   CM200_ROWBEGIN_LC			0xA7
#define   CM200_ROWBEGIN_HC			0xA8
#define   CM200_HSYNCEND_LC			0xA9
#define   CM200_HSYNCEND_HC			0xAA
#define   CM200_VSYNCEND_LC			0xAB
#define   CM200_VSYNCEND_HC			0xAC
#define   CM200_PARTCONTROL_C		0xAD
#define   CM200_WTBEGIN_LC			0xAE
#define   CM200_WTBEGIN_HC			0xAF
#define   CM200_WTEND_LC			0xB0
#define   CM200_WTEND_HC			0xB1
#define   CM200_PLL					0xB4

//  Dead pixel location definitions - should encode in array
//
//    deadpixels[5][23]
#define   CM200_COLDEAD0_L			0xC0
#define   CM200_COLDEAD0_H			0xC1
#define   CM200_ROWDEAD0_L			0xC2
#define   CM200_ROWDEAD0_H			0xC3

#define   CM200_COLDEAD1_L			0xC4
#define   CM200_COLDEAD1_H			0xC5
#define   CM200_ROWDEAD1_L			0xC6
#define   CM200_ROWDEAD1_H			0xC7

#define   CM200_COLDEAD2_L			0xC8
#define   CM200_COLDEAD2_H			0xC9
#define   CM200_ROWDEAD2_L			0xCA
#define   CM200_ROWDEAD2_H			0xCB

#define   CM200_COLDEAD3_L			0xC0
#define   CM200_COLDEAD3_H			0xC1
#define   CM200_ROWDEAD3_L			0xC2
#define   CM200_ROWDEAD3_H			0xC3

#define   CM200_COLDEAD23_L			0x7C
#define   CM200_COLDEAD23_H			0x7D
#define   CM200_ROWDEAD23_L			0x7E
#define   CM200_ROWDEAD23_H			0x7F

//  Register Settings

